#ifndef MSP_GLTK_HSLIDER_H_
#define MSP_GLTK_HSLIDER_H_

#include "slider.h"

namespace Msp {
namespace GLtk {

/**
Horizontal slider widget.  A special part named "slider" will be positioned at
the current value of the widget.
*/
class HSlider: public Slider
{
private:
	unsigned slider_size;

public:
	HSlider();

	virtual const char *get_class() const { return "hslider"; }

private:
	virtual void autosize_special(const Part &, Geometry &);
	virtual void rebuild_special(const Part &);

public:
	virtual void button_press(int, int, unsigned);
	virtual void button_release(int, int, unsigned);
	virtual void pointer_motion(int, int);
private:
	virtual void on_geometry_change();
	virtual void on_style_change();
};

} // namespace GLtk
} // namespace Msp

#endif
