#ifndef MSP_GLTK_STYLE_H_
#define MSP_GLTK_STYLE_H_

#include <msp/gl/color.h>
#include <msp/gl/font.h>
#include <msp/datafile/objectloader.h>
#include "part.h"

namespace Msp {
namespace GLtk {

class Resources;

/**
Styles define what wigets look like.  They are made up of Parts and some
generic properties.
*/
class Style
{
public:
	class Loader: public DataFile::CollectionObjectLoader<Style, Resources>
	{
	public:
		Loader(Style &, Resources &);

	private:
		void font(const std::string &);
		void font_color(float, float, float);
		void part(const std::string &);
		void unnamed_part();
	};

	typedef std::list<Part> PartSeq;

private:
	const GL::Font *font;
	unsigned font_size;
	GL::Color font_color;
	PartSeq parts;

public:
	Style();
	const GL::Font &get_font() const;
	unsigned get_font_size() const { return font_size; }
	const GL::Color &get_font_color() const { return font_color; }
	const PartSeq &get_parts() const { return parts; }
	const Part *get_part(const std::string &) const;
};

} // namespace GLtk
} // namespace Msp

#endif
